#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cstring>
#include <tuple>
#include <limits.h>
using namespace std;

ifstream fin("dragoni.in");
ofstream fout("dragoni.out");


using VI  = vector<int>;
using VB  = vector<bool>;
using VVI = vector<VI>;
using VP  = vector<pair<int, int>>;
using VVP = vector<VP>;
using TI  = tuple<int, int, int>;
using VTI = vector<TI>;

const int DIM = 801;
int n, m;
VVP G(DIM);
VB viz(DIM);
VI dm(DIM);

int Bfs(int x)
{
    queue<int> Q;
    int maxi = 0;
    Q.push(x);
    viz[x] = 1;
    while (!Q.empty())
    {
        x = Q.front();
        Q.pop();
        for (auto [y, d] : G[x])
            if (!viz[y] && d <= dm[1])
            {
                Q.push(y);
                viz[y] = 1;
                maxi = max(maxi, dm[y]);
            }
    }
    return maxi;
}

/// nod = (x, dr) x = insula, dr = dragonul cu care am ajuns in x
/// pt priority_queue: (dist, x, dr)   mai adugam distanta minima pana la insula x
int Dijkstra(int x)
{
    VVI dist(n + 1, VI(n + 1, INT_MAX));
    priority_queue<TI, vector<TI>, greater<TI>> Q;

    Q.emplace(0, x, 1);
    dist[x][1] = 0;
    while (!Q.empty())
    {
        auto tp = Q.top();
        Q.pop();
        int c = get<0>(tp);
        int x = get<1>(tp);
        int dr = get<2>(tp);  // dragonul cu care am ajuns in x
        int d = dm[dr];

        if (x == n)
            return c;

        for (auto [y, w] : G[x])
        {

            if (w <= d && dist[y][dr] > dist[x][dr] + w)  /// daca nu schimb dragonul in x
            {
                dist[y][dr] = dist[x][dr] + w;
                Q.emplace(dist[y][dr], y, dr);
            }

            if (w <= dm[x] && dist[y][x] > dist[x][dr] + w) /// daca schimb dragonul in x
            {
                dist[y][x] = dist[x][dr] + w;
                Q.emplace(dist[y][x], y, x);
            }
        }
    }
    return -1;
}

int main()
{
    int p, x, y, d;
    fin >> p >> n >> m;
    for (int i = 1; i <= n; i++)
        fin >> dm[i];

    for (int i = 1; i <= m; i++)
    {
        fin >> x >> y >> d;
        G[x].emplace_back(y, d);
        G[y].emplace_back(x, d);
    }

    if (p == 1)
        fout << Bfs(1);
    else
        fout << Dijkstra(1);

    return 0;
}
