/*
 * Se cere distanta minima de la nodul 1 la n,
 * daca se soseste in n parcurgand un numar par de muchii
 *
 */
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

struct Entry {
	int node, dist, p;   // nodul distanta si paritatea
	bool operator < (const Entry& e) const
	{
		return dist > e.dist;
	}
};

const int Inf = 0x3f3f3f3f;
using VI = vector<int>;
using PII = pair<int, int>;

vector<vector<PII>> G;
int n, m;
vector<VI> d;

void Read();
void Dijkstra(int x, vector<VI>& d);

int main()
{
	Read();
	Dijkstra(1, d);

	if (d[n][0] != Inf)
		cout << d[n][0] << '\n';
	else
		cout << -1 << '\n';
}


void Dijkstra(int x, vector<VI>& d)
{
	int dx, p;

	priority_queue<Entry> Q;
	d = vector<VI>(n + 1, vector<int>(2, Inf));

	d[x][0] = 0; // nr de muchii pare la plecare e 0
	d[x][1] = 0; // nr de muchii pare la plecare e 0
	Q.emplace(x, 0, 0);
	Q.emplace(x, 0, 1);
	while (!Q.empty())
	{
		x = Q.top().node;
		dx = Q.top().dist;
		p = Q.top().p;
		Q.pop();

		if (d[x][p] < dx )
			continue;

		for (auto [y, w] : G[x])
		{
			if (d[y][1] > d[x][0] + w) // daca ajung in y pe un numar impar de muchii
			{
				d[y][1] = d[x][0] + w;
				Q.push({y, d[y][1], 1});
			}

			if (d[y][0] > d[x][1] + w) // daca ajung in y pe un numar par de muchii
			{
				d[y][0] = d[x][1] + w;
				Q.emplace(y, d[y][0], 0);
			}
		}

	}
}

void Read()
{
	int x, y, w;
	cin >> n >> m;
	G = vector<vector<PII>>(n + 1);

	while (m--)
	{
		cin >> x >> y >> w;
		G[x].emplace_back(y, w);
		G[y].emplace_back(x, w);
	}

}
;
