#include <fstream>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

#define Inf 0x3f3f3f3f

ifstream fin("LANT9.IN");
ofstream fout("lanterna.out");

struct Entry {
	int x, w, t;      // nod, energia ramasa, timpul minim de la 1 la x
	bool operator <(const Entry& e) const
	{
		return t > e.t;
	}
};

using VI = vector<int>;
using VVI = vector<VI>;
using VE = vector<Entry>;
using VVE = vector<VE>;

VVE G;
VVI t;     /// t[x][e] - timpul minim de la nodul 1 la nodul x, daca in baterie mai sunt e wati

bool p[55];   // prieteni
int m, n, K;
int tmin, wmin;

void Read();
void Cbin();
int Dijkstra(int x);
void Write();

int main()
{
    Read();
    tmin = Dijkstra(K);
    wmin = K;
    Cbin();
    Write();

    fout.close();
    return 0;
}

int Dijkstra(int wn) /// en nominala a bateriei
{
	int x, wx;
	int we, te, y;       // costul si energia pe muchia de la x la y
	priority_queue<Entry> Q;
	t = VVI(n + 1, VI(wn + 1, Inf));

	t[1][wn] = 0;
	Q.emplace(1, wn, 0);

	while (!Q.empty())
	{
		x = Q.top().x;
		tmp = Q.top().t;
		wx = Q.top().w;  // wx - energia la iesirea din nodul x
		// adaugat acum
        if (t[x][wx] < tmp) continue;

		Q.pop();

		for (auto e : G[x] )
		{
			y = e.x; we = e.w; te = e.t;

            if (wx < we)  // nu ajunge energia din x sa ajung in y
                continue;

			int wf; // energia finala in y
			if (p[y])  // prieten
                wf = wn;
            else
				wf = wx - we;

            if (t[x][wx] + te < t[y][wf])
            {
                t[y][wf] = t[x][wx] + te;
                Q.emplace(y, wf, t[y][wf]);
            }
		}
	}

	int tf = Inf;
	for (int i = 0; i <= wn; ++i) // redundant
        if (t[n][i] < tf)
            tf = t[n][i];
    return tf;

}

void Read()
{
    int i;
    fin >> n >> K;
    G = VVE(n + 1);

    for (i = 1; i <= n; i++)
        fin >> p[i];
    int a, b, timp, w;
    fin >> m;
    for (i = 1; i <= m; i++)
    {
        fin >> a >> b >> timp >> w;
        G[a].emplace_back(b, w, timp);
        G[b].emplace_back(a, w, timp);
    }
}

void Cbin()
{
    int l = 1, r = K, m, timp;
    while (l <= r)
    {
        m = (l + r)/2;
        timp = Dijkstra(m);
        if (timp > tmin)
			l = m + 1;
        else
             if (timp == tmin )
             {
                wmin = m;
                r = m - 1;
             }
    }
}

void Write()
{
    fout << tmin << " " << wmin << "\n";
}
