#include <fstream>
#include <vector>
#include <queue>
using namespace std;
ifstream fin("lanterna.in");
ofstream fout("lanterna.out");
const int inf = 0x3f3f3f3f;

struct edge {
	int y, t, w;
};

using VI = vector<int>;
using VVI = vector<VI>;
using VVE = vector<vector<edge>>;

void BF(int x);
VVE g;
VVI d;
int n, k, m, x, y, t, w, tmin = inf, timp;
bool prieten[1002];

int main()
{
	fin >> n >> k;
	for (int i = 1; i <= n; ++i)
		fin >> prieten[i];
	fin >> m;
	g = VVE(n + 1);
	for (int i = 1; i <= m; ++i)
	{
		fin >> x >> y >> t >> w;
		g[x].push_back({y, t, w});
		g[y].push_back({x, t, w});
	}

	BF(k);

	for (int i = 0; i <= k; ++i)
		tmin = min(tmin, d[n][i]);

	fout << tmin << '\n';

	int st = 1, dr = k, mij, rez = k;
	while (st <= dr)
	{
		mij = (st + dr) / 2;
		BF(mij);
		timp = inf;
		for (int i = 0; i <= mij; ++i)
			timp = min(timp, d[n][i]);
		if (timp == tmin)
		{
			rez = mij;
			dr = mij - 1;
		}
		else st = mij + 1;
	}
	fout << rez;
	fin.close();
	fout.close();
	return 0;
}

void BF(int x)
{
	queue<pair<int, int>> q;
    q.push({1, x});
    d = VVI(n + 1, VI(x + 1, inf));
    d[1][x] = 0;
    int nod, p;
    while (!q.empty())
    {
        nod = q.front().first;
        p   = q.front().second;
        q.pop();
        for (const edge& e : g[nod])
        {
            if (p - e.w >= 0 && d[e.y][p - e.w] > d[nod][p] + e.t)
            {
                d[e.y][p - e.w] = d[nod][p] + e.t;
                if (prieten[e.y] && d[e.y][x] > d[e.y][p - e.w])
				{
					d[e.y][x] = d[e.y][p - e.w];
					q.push({e.y, x});
				}
                else q.push({e.y, p - e.w});
            }
        }
    }
}
