#include <fstream>
#include <queue>
using namespace std;


ifstream fin ("ZMEU.8");
ofstream fout ("zmeu.out");

const short NMAX = 505, PMAX = 205;
const short var = 11;

int t[PMAX][NMAX];  /// t[i][j] - distanta minima (TIMPUL MINIM) sa ies din nodul i cu capete ramase j

int d[PMAX], ct[PMAX]; /// d[i] durata povestii i, c[i] = capete taiate in povestea i
int n, p, k;

bool adj[PMAX][PMAX];

struct Stare {
    int x, t, cr;   // Stare: timp_la iesire din povestea x, capete ramase la iesirea din x

    bool operator < (const Stare &e) const
    {
        return t > e . t;
    }
};

priority_queue<Stare> Q;

int main()
{
    int x, y;
    bool ok = false;

    fin >> n >> p >> k;  // n - numarul initial de capete

    for (int i = 1 ; i <= p ; i++)
        fin >> d[i] >> ct[i];   // (durata, capete taiate) pt povestea i

    for (int i = 1 ; i <= p ; i++)
        for (int j = 1 ; j <= p ; j++)
            if (i != j)
                adj[i][j] = true;

    for (int i = 1 ; i <= k ; i++)
        fin >> x >> y, adj[x][y] = false;  // nu se poate trece din povestea x in povestea y

    for (int i = 1 ; i <= p ; i++)
        for (int j = 1 ; j <= n; j++)
            t[i][j] = (1 << 30);

    if(ct[1] >= n)
    {
        fout << "-1\n";
        return 0;
    }

    t[1][n - ct[1]] = d[1];  // la iesirea din nodul 1 (povestea 1_
    Q.push({1, d[1], n - ct[1]});
	Stare nod;
    while (!Q.empty())
    {
        nod = Q.top();
		Q.pop();
        if (nod.x == p)   // am ajuns la final
        {
            fout << nod.t << "\n";
            return 0;
        }

        for (int y = 1; y <= p; y++)
        {
            if (nod.x == 1 && y == p && !ok)
            {
                ok = true;
                continue;
            }

            if (nod.cr > ct[y] && t[y][nod.cr - ct[y]] > t[nod.x][nod.cr] + d[y] && adj[nod.x][y])
            {
                t[y][nod.cr - ct[y]] = t[nod.x][nod.cr] + d[y];
                Q.push({y, t[y][nod.cr - ct[y]], nod.cr - ct[y]});
            }
        }
    }

    fout << "-1\n";

    fin.close();
    fout.close();

    return 0;

}
