// https://www.infoarena.ro/problema/color2
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

ifstream fin("color2.in");
ofstream fout("color2.out");

const int MAXN = 16005;

vector<int> G[MAXN], sol;
int fa[MAXN], br[MAXN], s[MAXN];
bool win_up[MAXN];   // win_up[i] = true daca jucatorul care incepe are strategie sigura de castig
                     // in cazul in care el coloreaza nodul i, iar al doilea jucator coloreaza
                     // in continuare, unul din fiii lui i

bool win_down[MAXN]; // win_down[i] = true daca jucătorul care incepe are strategie sigura de castig
                     // in cazul in care el colorează nodul i, iar al doilea jucător colorează
                     // in continuare, tatal lui i.

void DfsDown(int x)
{
	int son[2], k = 0;
	win_down[x] = true;
	for (int y : G[x])
	{
		DfsDown(y);
		son[k++] = y;
	}

	if (k != 0) /// daca x are fii
		win_down[x] = !win_down[son[0]] && !win_down[son[1]];
}

void DfsUp(int x)
{
	win_up[x] = !win_up[fa[x]] || win_down[br[x]];
	for (int y : G[x])
		DfsUp(y);
}

int main()
{
	int n, father, son;

	fin >> n;
	for (int i = 1; i < n; ++i)
	{
		fin >> father >> son;
		G[father].push_back(son);

		fa[son] = father;
		if (s[father] != 0 )
		{
		   br[s[father]] = son; // brother[fiu[father]] = son
		   br[son] = s[father];
		}
		else
		   s[father] = son;    // fiu[father] = son
	}

	DfsDown(1);
	DfsUp(1);

	for (int i = 1; i <= n; ++i)
		if (win_up[i] & win_down[i])
			sol.push_back(i);

	fout << sol.size() << "\n";
	for (size_t i = 0; i < sol.size(); ++i)
		fout << sol[i] << " ";

	return 0;
}
